;//**   File: gprintf.asm
;//**
;//**   Created by GODlike (www.ancientritual.tk)

.686
.model flat, c
option casemap: none

gStrcpy       proto stdcall :dword, :dword
gIntToStr     proto stdcall :dword, :dword
gIntToStrHex  proto stdcall :dword, :dword
gDoubleToStr  proto stdcall :dword, :qword
WriteFile     proto stdcall :dword, :dword, :dword, :dword, :dword
GetStdHandle  proto stdcall :dword
STD_OUTPUT_HANDLE equ -11

.code
;========================================
;   void gPrintf (char* pcFormat, ...)
;========================================
OPTION EPILOGUE:NONE
gPrintf proc pcFormat:dword, param0:dword
	;/-------------------------------------------\
	;| A func just like printf                   |
	;| Format: %i: integer                       |
	;|         %x: integer in hexademical format |
	;|         %c: char                          |
	;|         %s: string                        |
	;|         %e: double floating point number  |
	;\-------------------------------------------/
	local pcTmp[400]:byte
	local tmp:dword
	local handle:dword
	push edx
	push esi
	push ecx
	
	lea edx, pcTmp 
	mov esi, pcFormat
	lea ecx, param0
	
	mov al, byte ptr [esi]
	inc esi
	
	;-------------
	;the main loop
	;-------------
	@@:
	.if al == '%'
		mov al, byte ptr [esi]
		inc esi
		cmp al, 's'
		je case_s
		cmp al, 'i'
		je case_i
		cmp al, 'x'
		je case_x
		cmp al, 'e'
		je case_e
		cmp al, 'c'
		je case_c
		jmp default
		case_s:
			invoke gStrcpy, edx, dword ptr [ecx]
			add edx, eax
			add ecx, 04h
			jmp case_break
		case_i:
			invoke gIntToStr, edx, dword ptr [ecx]
			add edx, eax
			add ecx, 04h
			jmp case_break
		case_x:
			invoke gIntToStrHex, edx, dword ptr [ecx]
			add edx, eax
			add ecx, 04h
			jmp case_break
		case_e:
			invoke gDoubleToStr, edx, qword ptr [ecx]
			add edx, eax
			add ecx, 08h
			jmp case_break
		case_c:
			mov al, byte ptr [ecx]
			add ecx, 04h
		default:
			mov byte ptr [edx], al
			inc edx
		case_break:
	.else
		mov byte ptr [edx], al
		inc edx
	.endif
	mov al, byte ptr [esi]
	inc esi
	test al, al
	jne @B
	
	;----------------
	;print the string
	;----------------
	lea eax, pcTmp
	sub edx, eax                               ;edx has the string's length
	invoke GetStdHandle, STD_OUTPUT_HANDLE     ;get console output handle
	mov ecx, eax
	invoke WriteFile, ecx, addr pcTmp, edx, ADDR tmp, 00h 
	
	pop ecx
	pop esi
	pop edx
	mov esp, ebp
	pop ebp
	ret
gPrintf endp
OPTION EPILOGUE:EpilogueDef


end